<html>
<head>
<title>Disco / Thor / Tyr Setup</title>
</head>
<body>
<p>This script helps setup the disco / thor / tyr package - these components are fully integrated into the Reason CMS, but might
be useful outside of the Reason framework.</p>

<?php
// this file has all kinds of crap that it does not need for this limited application but oh well
// do what we can to enable error reporting
ini_set("display_errors","On");
error_reporting (E_ALL);

// Environmental checks - include path and basic location of files needed to perform other checks
if (isset($_POST['do_it_pass']) == false)
{
	echo '<h3>Verifying Environment</h3>';
	echo '<h4>Checking package availability</h4>';
	//check_php_include_path();
	echo '...attempting to load paths.php, which loads the package_settings - a fatal error here probably means that the require_once statement in paths.php is referencing a file that does not exist<br/>';
	if (!file_exists('paths.php')) die_with_message('<p class="error">ERROR: The file paths.php in the disco_thor_tyr directory does not appear to exist - check permissions and file paths.</p>');
	include_once('paths.php'); // paths loads the package_settings file
	if (!defined('INCLUDE_PATH'))
	{
		die_with_message('<p class="error">ERROR: The file paths.php was included, but did not properly include the package_settings.php file. Modify the require_once statement in paths.php
						  to include an absolute file system path reference to package_settings.php</p>
						  <p>Unless you are placing your settings files in a different location than the default, the absolute path of the package_settings.php file 
						  should probably look like this:</p>
						  <p><pre>'.$_SERVER['DOCUMENT_ROOT'] . dirname($_SERVER['PHP_SELF']) .'/settings/package_settings.php</pre></p>');
	}
	else
	{
		$included_so_far = get_included_files();
		$package_settings_path = array_pop($included_so_far);
		echo '...paths.php loaded package_settings.php<br/>';
		echo '<p><strong>Package settings path</strong>: ' . $package_settings_path . '</p>';
		echo '<h4>Checking component availability</h4>';
		if (is_readable(INCLUDE_PATH . 'setup.php'))
		{
			// verify settings files loaded by header.php before we load the header
			check_environment_and_trailing_slash(WEB_PATH, 'web path', 'Check the WEB_PATH constant in package_settings.php.</p><p>
								 The value should probably be</p>
								 <p><pre>'.$_SERVER['DOCUMENT_ROOT'].'/</pre>');
			check_environment(CARL_UTIL_INC.'error_handler/error_handler.php', 'error handler', 'Verify the path to CARL_UTIL_INC in package_settings.php');
			check_environment(DB_CREDENTIALS_FILEPATH, 'db credentials xml file', 'Verify the DB_CREDENTIALS_FILEPATH in package_settings.php and permissions');
			check_environment(DISCO_INC.'disco.php', 'disco include path', 'Verify the path to DISCO_INC in package_settings.php');
			check_environment(TYR_INC.'tyr.php', 'tyr include path', 'Verify the path to TYR_INC in package_settings.php');
			check_environment(THOR_INC.'thor.php', 'thor include path ', 'Verify the path to THOR_INC in package_settings.php');
			check_environment(XML_PARSER_INC.'xmlparser.php', 'xml parser', 'Verify the path to XML_PARSER_INC in package_settings.php');
			check_error_handler_log_file_dir();
			echo '<p style="color: green;"><strong>...the environment has been loaded</strong></p>';
		}
		else die_with_message('<p class="error">ERROR: The INCLUDE_PATH constant ('.INCLUDE_PATH.') appears to be invalid.</p>
							   <p>Check package_settings.php to make sure the value is correct - it should probably be set to:</p>
							   <p><pre>'.$_SERVER['DOCUMENT_ROOT'] . dirname($_SERVER['PHP_SELF']) .'/</pre></p>');
	}
}
	
if (isset($_POST['do_it_pass']) == false)
{
	if (perform_checks() == false)
	{
		die_with_message('<p>Please address the identified problems and run this script again.</p>');
	}
	else echo '<p><a href="index.php">You should be able to proceed</a></p>';
}
?>
</body>
</html>

<?
function check_php_include_path()
{
	$include_path = ini_get('include_path');
	
	// method one - found to be unpredicable in some shared hosting environments (ie. dreamhost)
	$cur_path = dirname(__FILE__);
	$include_path_set = strpos($include_path, $cur_path);
	
	// method two - if this works the path is probably okay
	$alt_cur_path = $_SERVER['DOCUMENT_ROOT'] . dirname($_SERVER['PHP_SELF']);
	$alt_include_path_set = strpos($include_path, $alt_cur_path);
	
	if (($include_path_set === false) && ($alt_include_path_set === false))
	{
		$include_path_separator = (setup_check_is_windows()) ? ';' : ':';
		die_with_message('<p class="error"><strong>ERROR:</strong> The reason_package directory must be part of your php include path.</p><p>Your current include path is:</p>
						  <p><pre>'.$include_path.'</pre></p>
						  <p>Please modify the include path line in your php.ini file so that it reads as follows</p>
						  <p><pre>include_path = "'.$include_path.$include_path_separator.$cur_path.'"</pre></p>
						  <p>If you do not have access to modify php.ini you may be able to create an .htaccess 
						  file that sets the include path. For this to work, AllowOverride Option must be enabled in your httpd.conf file. The .htaccess rule
						  should read as follows:</p>
					<p><pre>php_value include_path ".'.$include_path_separator.$cur_path.'"</pre></p>
					<p>Please run the script again after your include path has been properly setup</p>');
	}
	else
	{
		echo '...the php include_path includes the reason_package directory<br/>';
	}
}

function setup_check_is_windows()
{
	if (strtoupper(substr(PHP_OS,0,3) == 'WIN')) return true;
	else return false;
}

function perform_checks()
{
	$check_passed = 0;
	$check_failed = 0;
	echo '<h3>Performing Basic Checks</h3>';
	// perform checks - each check should echo a success or failure string, and return true if successful
	// $check_passed and $check_failed increment accordingly. perform_checks returns true if all checks pass
	
	if (verify_mysql(THOR_FORM_DB_CONN, 'THOR_FORM_DB_CONN', 'thor_settings.php', false)) $check_passed++;
	else $check_failed++;
	
	if (http_host_check()) $check_passed++;
	else $check_failed++;
	
	echo '<h3>Performing Directory and File Checks</h3>';
	
	if (data_dir_writable(WEB_PATH, 'WEB_PATH')) $check_passed++;
	else $check_failed++;
	
	echo '<h3>Summary</h3>';
	echo '<ul>';
	echo '<li class="success">'.$check_passed.' checks were successful</li>';
	echo '<li class="error">'.$check_failed.' checks failed</li>';
	echo '</ul>';
	if ($check_failed == 0) return true;
	else return false;
}

function verify_mysql($db_conn_name, $constant_name, $constant_location, $check_for_tables = false) // see if we can connect to mysql using the connection parameters specified in REASON_DB
{
	include_once( INCLUDE_PATH . 'xml/xmlparser.php' ); // we have verified this exists already
	$db_file = DB_CREDENTIALS_FILEPATH; // we have verified this exists
	$xml = file_get_contents($db_file);
	if(!empty($xml))
	{
		$xml_parse = new XMLParser($xml);
		$xml_parse->Parse();
		foreach ($xml_parse->document->database as $database)
		{
			$tmp = array();
			$tmp['db'] = $database->db[0]->tagData;
			$tmp['user'] = $database->user[0]->tagData;
			$tmp['password'] = $database->password[0]->tagData;
			$tmp['host'] = $database->host[0]->tagData;
			$db_info_all[$database->connection_name[0]->tagData] = $tmp;
		}
	}
	else return msg('<span class="error">mysql connection ' . $db_conn_name . ' check failed</span> - the db connection xml file does not appear to have any contents', false);
	$db_info = (isset($db_info_all[$db_conn_name])) ? $db_info_all[$db_conn_name] : false;
	if ($db_info === false) return msg ('mysql check failed - ' . $db_conn_name . ' is an invalid connection name.
		<p>Make sure the constant ' . $constant_name . ' in ' . $constant_location . ' maps to the connection name in your db connection xml file</p>', false);
	
	if (empty($db_info['db']) || empty($db_info['user']) || empty($db_info['password']) || empty($db_info['host']))
	{
		return msg('<span class="error">mysql connection ' . $db_conn_name . ' check failed</span> - the db connection xml file for does not have full information for the connection named ' . $db_conn_name . '.
		<p>Check the constant ' . $constant_name . ' in ' . $constant_location . ' to make sure it matches the connection name in your db connection xml file.</p>', false);
	}
	$db = mysql_connect($db_info['host'], $db_info['user'], $db_info['password']);
	if (empty($db))
	{
		return msg('<span class="error">mysql connection ' . $db_conn_name . ' check failed</span> - count not connect to server - could be one of the following
					<ul>
					<li>Improper username and/or password in the db credentials file</li>
					<li>Improper mysql hostname - currently set to ' .$db_info['host'].'</li>
					<li>The user ' . $db_info['user'] . ' needs to have been granted permission to connect to ' . $db_info['host'] . ' from the web server</li>
					</ul>', false);
	}
	else
	{
		if( !mysql_select_db($db_info[ 'db' ], $db) )
		{
			return msg('<span class="error">mysql connection ' . $db_conn_name . ' check failed</span> - connected to host as user ' . $db_info['user'] . ' but could not select database ' . $db_info['db'] . '. Check the db credential xml file and user privileges', false);
		}
	}
	
	// check_for_tables
	if ($check_for_tables)
	{
		$result = db_query('show tables');
		$table_count = mysql_num_rows($result);
		if ($table_count == 0)
		{
			return msg('<span class="error">mysql connection ' . $db_conn_name . ' check failed</span> - 
				   The database ' . $db_info['db'] . ' does not appear to have any tables.<p><a href="./install.htm#database_setup">Consult the reason install documentation</a> 
				   for information on how to import the reason database.</p>', false);
		}
	}
	return msg('<span class="success">mysql connection ' . $constant_name . '('.$db_conn_name . ') check passed</span>', true);
}

function http_host_check()
{
	if ($_SERVER['HTTP_HOST'] == HTTP_HOST_NAME) return msg('<span class="success">http host check passed</span>', true);
	else return msg('<span class="error">http host check failed</span> - make sure the HTTP_HOST_NAME constant in paths.php is equivalent to the $_SERVER[\'HTTP_HOST\'] value', false);
}

function data_dir_writable($dir, $name)
{
	if (is_writable($dir)) return msg('<span class="success">'.$name . ' directory is writable</span> - check passed', true);
	else return msg ('<span class="error">'.$name . ' directory not writable - failed</span>. Make sure apache user has write access to ' . $dir, false);
}

function check_file_readable($file, $name, $extra = '')
{
	if (is_readable($file)) return msg('<span class="success">'.$name . ' file is readable</span> - check passed', true);
	else return msg ('<span class="error">'.$name . ' file not readable - failed</span>. Make sure ' .$file. ' exists and apache user has read access to it. '.$extra, false);
}

function check_environment($path, $check_name, $error_msg)
{
	if (file_exists($path)) return msg($check_name . ' found', true);
	else die_with_message('<p class="error">ERROR: '.$check_name . ' not found</p><p>'.$error_msg.'</p><p>Please fix the problem and run this script again.</p>');
}

function check_environment_and_trailing_slash($path, $check_name, $error_msg)
{
	if (file_exists($path))
	{
		// lets make sure the last character of the path is a trailing slash
		if (substr($path, -1) != '/') die_with_message('<p class="error">ERROR: '.$check_name . ' missing trailing slash.</p><p>'.$error_msg.'</p><p>Please fix the problem and run this script again.</p>');
		return msg($check_name . ' found', true);
	}
	else die_with_message('<p class="error">ERROR: '.$check_name . ' not found</p><p>'.$error_msg.'</p><p>Please fix the problem and run this script again.</p>');
}

function check_error_handler_log_file_dir()
{
	if (!file_exists(PHP_ERROR_LOG_FILE))
	{
		$success = false;
		// attempt to create the file.
		$file = PHP_ERROR_LOG_FILE;
		if ($file_handle = fopen($file,"a")) fclose($file_handle);
		else
		{
			die_with_message('<p class="error">The error handler log file is set to ' . PHP_ERROR_LOG_FILE . ' - this file does not exist, and
				   could not be created. Please create the file, and make sure the apache user can write to it. You can alternatively change the
				   PHP_ERROR_LOG_FILE constant in error_handler_settings.php to a writable directory. After you have fixed the problem
				   run this script again.</p>');
		}
	}
	if (!is_writable(PHP_ERROR_LOG_FILE))
	{
		die_with_message('<p class="error">The error handler log file is set to ' . PHP_ERROR_LOG_FILE . ' - this file is not writable.
				   Please make the file writable to the apache user or change the value of the constant PHP_ERROR_LOG_FILE in error_handler_settings.php
				   to a writable file. After you have fixed the problem run this file again.</p>');
	}
	return true;
}

function msg($msg, $bool)
{
	echo '...' . $msg;
	echo '<br />';
	return $bool;
}

function admin_user_HTML()
{
	echo '<h3>Create Admin User</h3>';
	echo '<p>Your Reason instance does not have an administrative user. In order to login and create users, we need to setup the administrative 
user. Press submit to create the user and a random password - MAKE SURE TO WRITE DOWN THE PASSWORD!. You can change the password later but will
need it to login</p>';
echo '<form method="post"><input type="submit" name="do_it_pass" value="Do It!" /></form>';
}

function create_pass()
{
	$pass = '';
	$chars = "1234567890abcdefghijklmnopqrstuvwxyz";
	while (strlen($pass) < 6)
	{
		$my_char = $chars{rand(0,35)};
		if (!is_numeric($my_char))
		{
			if (rand(0,1) == 0) $my_char = strtoupper($my_char);
		}
		$pass .= $my_char;
	}
	return $pass;
}

function die_with_message($msg)
{
	echo $msg;
	die;
}
?>

